      subroutine beta ( p, q, bt )

c*********************************************************************72
c
cc BETA computes the Beta function B(p,q).
c
c  Licensing:
c
c    This routine is copyrighted by Shanjie Zhang and Jianming Jin.  However, 
c    they give permission to incorporate this routine into a user program 
c    provided that the copyright is acknowledged.
c
c  Modified:
c
c    12 March 2012
c
c  Author:
c
c    Shanjie Zhang, Jianming Jin.
c
c  Reference:
c
c    Shanjie Zhang, Jianming Jin,
c    Computation of Special Functions,
c    Wiley, 1996,
c    ISBN: 0-471-11963-6,
c    LC: QA351.C45
c
c  Parameters:
c
c    Input, double precision P, Q, the parameters.
c    0 < P, 0 < Q.
c
c    Output, double precision BT, the value of B(P,Q).
c
      implicit none

      double precision bt
      double precision gp
      double precision gpq
      double precision gq
      double precision p
      double precision ppq
      double precision q

      call gamma ( p, gp )
      call gamma ( q, gq )
      ppq = p + q
      call gamma ( ppq, gpq )
      bt = gp * gq / gpq

      return
      end
